shader_type canvas_item;
render_mode blend_disabled;

uniform float iTime;
uniform int iFrame;
uniform sampler2D iChannel0;
uniform sampler2D iChannel1;
uniform sampler2D iChannel2;
uniform sampler2D iChannel3;
uniform float expl_time;
uniform vec2 draw_at;
uniform vec3 iMouse;

// https://www.shadertoy.com/view/Xsd3DB

void mainImage( out vec4 fragColor, in vec2 fragCoord, in vec2 iResolution )
{
   vec3 e = vec3(vec2(1.)/iResolution.xy,0.);
   vec2 q = fragCoord.xy/iResolution.xy;
   
   vec4 c = texture(iChannel1, q);
   
   float p11 = c.x;
   
   float p10 = texture(iChannel0, q-e.zy).x;
   float p01 = texture(iChannel0, q-e.xz).x;
   float p21 = texture(iChannel0, q+e.xz).x;
   float p12 = texture(iChannel0, q+e.zy).x;
   
   float d = 0.;
    
   if(expl_time<0.3)
   {
      d = 50.*smoothstep(4.5,.5,length(draw_at.xy - fragCoord.xy));
   }

   d += -(p11-.5)*2. + (p10 + p01 + p21 + p12 - 2.);
   d *= .97; 
   d *= min(1.,float(iFrame));
   d = d*.5 + .5;
   
   fragColor = vec4(d, 0, 0, 1);
}


void fragment(){
	vec2 iResolution=floor(1./TEXTURE_PIXEL_SIZE);
	mainImage(COLOR,UV*iResolution,iResolution);
}