shader_type canvas_item;
render_mode blend_disabled;

uniform float iTime;
uniform int iFrame;
uniform sampler2D iChannel0;
uniform sampler2D iChannel1;
uniform sampler2D iChannel2;
uniform sampler2D iChannel3;

void mainImage( out vec4 fragColor, in vec2 fragCoord, in vec2 iResolution)
{
    vec2 q = fragCoord.xy/iResolution.xy;

    vec3 e = vec3(vec2(1.)/iResolution.xy,0.);
    float p10 = texture(iChannel0, q-e.zy).x;
    float p01 = texture(iChannel0, q-e.xz).x;
    float p21 = texture(iChannel0, q+e.xz).x;
    float p12 = texture(iChannel0, q+e.zy).x;
    
    vec3 grad = normalize(vec3(p21 - p01, p12 - p10, 1.));
	vec2 fc=(fragCoord.xy/iResolution);
	fc.y=1.-fc.y;
    vec3 c = texture(iChannel1, fc + grad.xy*.35).rgb;
	c = max(c,c*0.2+0.5*texture(iChannel2, fc + grad.xy*.35).rgb);
    vec3 light = normalize(vec3(.2,-.5,.7));
    float diffuse = dot(grad,light);
    float spec = pow(max(0.,-reflect(light,grad).z),32.);
    fragColor = vec4(c*max(diffuse,0.) + spec,1.);
	
}
void fragment(){
	vec2 iResolution=floor(1./TEXTURE_PIXEL_SIZE);
	mainImage(COLOR,UV*iResolution,iResolution);
}